diff -urN sourceold/scripts/ms.h source/scripts/ms.h
--- sourceold/scripts/ms.h	1970-01-01 10:00:00.000000000 +1000
+++ source/scripts/ms.h	2020-04-03 08:27:17.955761900 +1000
@@ -0,0 +1,153 @@
+#pragma once
+#include "scripts.h"
+
+
+#define MS_BASE                                          0xDA000000
+
+#define CUSTOM                                           0x00010000
+#define TIMER                                            0x00020000
+#define ACTION                                           0x00030000
+
+#define CUSTOM_TARGETPAINTER_TARGET_OBJECT_CREATED       (MS_BASE|CUSTOM|100201)
+#define CUSTOM_TARGETPAINTER_TARGET_OBJECT_DESTROY_SELF  (MS_BASE|CUSTOM|100202)
+
+
+#define CUSTOM_AI_SOLDIER_DIED                           (MS_BASE|CUSTOM|100501)
+#define CUSTOM_AI_VEHICLE_DIED                           (MS_BASE|CUSTOM|100502)
+#define CUSTOM_AI_GO_TO_VEHICLE                          (MS_BASE|CUSTOM|100503)
+#define CUSTOM_AI_ARRIVED_TO_VEHICLE                     (MS_BASE|CUSTOM|100504)
+#define CUSTOM_AI_VEHICLE_REQUEST_ENTER                  (MS_BASE|CUSTOM|100505)
+#define CUSTOM_AI_VEHICLE_EXITED                         (MS_BASE|CUSTOM|100506)
+#define CUSTOM_AI_REQUEST_REFUND                         (MS_BASE|CUSTOM|100507)
+#define CUSTOM_AI_TRANSPORT_ARRIVED                      (MS_BASE|CUSTOM|100508)
+#define CUSTOM_AI_VEHICLE_AMMO_EMPTY                     (MS_BASE|CUSTOM|100509)
+#define CUSTOM_AI_CHECK_REPAIR_NEEDED                    (MS_BASE|CUSTOM|100510)
+#define CUSTOM_AI_GO_TO_REFILL                           (MS_BASE|CUSTOM|100511)
+#define CUSTOM_AI_GO_TO_RELOAD                           (MS_BASE|CUSTOM|100512)
+#define CUSTOM_AI_GO_TO_EXIT_VEHICLE                     (MS_BASE|CUSTOM|100513)
+#define CUSTOM_AI_ARRIVED_TO_REFILL                      (MS_BASE|CUSTOM|100514)
+#define CUSTOM_AI_ARRIVED_TO_EXIT_VEHICLE                (MS_BASE|CUSTOM|100515)// TODO: use generic ARRIVED_TO_SECONDARY_TASK custom.
+#define CUSTOM_AI_REFILL_COMPLETE                        (MS_BASE|CUSTOM|100516)
+#define CUSTOM_AI_SEARCH_FOR_VEHICLE                     (MS_BASE|CUSTOM|100517)
+#define CUSTOM_AI_DEACTIVATE_AI                          (MS_BASE|CUSTOM|100518)
+#define CUSTOM_AI_GO_SWITCH_OBJECTIVE                    (MS_BASE|CUSTOM|100519)
+#define CUSTOM_AI_REQUEST_PATROL_POINT                   (MS_BASE|CUSTOM|100520)
+#define CUSTOM_AI_GO_TO_PATROL_POINT                     (MS_BASE|CUSTOM|100521)
+#define CUSTOM_AI_CHECK_GO_HOME                          (MS_BASE|CUSTOM|100522)
+#define CUSTOM_AI_SEND_PUBLIC_MESSAGE                    (MS_BASE|CUSTOM|100523)
+#define CUSTOM_AI_ADD_RADAR_TARGET                       (MS_BASE|CUSTOM|100524)
+#define CUSTOM_AI_CHECK_RADAR_TARGETS                    (MS_BASE|CUSTOM|100525)
+#define CUSTOM_AI_ENEMY_KILLED                           (MS_BASE|CUSTOM|100526)
+#define CUSTOM_AI_ADD_ALLY_TARGET                        (MS_BASE|CUSTOM|100527)
+#define CUSTOM_AI_REPAIR_NEEDED                          (MS_BASE|CUSTOM|100528)
+#define CUSTOM_AI_REPAIR_COMPLETE                        (MS_BASE|CUSTOM|100529)
+
+#define CUSTOM_AI_COOP_NEXT_RALLYPOINT                   (MS_BASE|CUSTOM|100601)
+#define CUSTOM_AI_COOP_ARRIVED_TO_RALLYPOINT             (MS_BASE|CUSTOM|100602)
+#define CUSTOM_AI_COOP_GROUPRUSH_COMPLETE                (MS_BASE|CUSTOM|100603)
+#define CUSTOM_AI_COOP_STOP_SECONDARY_OBJECTIVE          (MS_BASE|CUSTOM|100604)
+
+#define CUSTOM_AI_COOP_PLAYER_RADIO_MESSAGE              (MS_BASE|CUSTOM|100701)
+#define CUSTOM_AI_COOP_PLAYER_FOLLOW                     (MS_BASE|CUSTOM|100702)
+#define CUSTOM_AI_COOP_PLAYER_FOLLOW_COVER               (MS_BASE|CUSTOM|100703)
+#define CUSTOM_AI_COOP_PLAYER_FOLLOW_STOP                (MS_BASE|CUSTOM|100704)
+#define CUSTOM_AI_COOP_PLAYER_DEFEND_BASE                (MS_BASE|CUSTOM|100705)
+#define CUSTOM_AI_COOP_PLAYER_CREATE_OBJECTIVE           (MS_BASE|CUSTOM|100706)
+#define CUSTOM_AI_COOP_PLAYER_DESTROY_OBJECTIVE          (MS_BASE|CUSTOM|100707)
+
+#define CUSTOM_AI_ORDER_MOVE                             (MS_BASE|CUSTOM|100801)
+#define CUSTOM_AI_ORDER_ATTACK                           (MS_BASE|CUSTOM|100802)
+#define CUSTOM_AI_ORDER_DEFEND                           (MS_BASE|CUSTOM|100803)
+
+#define TIMER_AI_CONTROLLER_PLAYERCHECK                  (MS_BASE|TIMER|100501)
+#define TIMER_AI_OBJECT_SPAWN_COUNTDOWN                  (MS_BASE|TIMER|100502)
+#define TIMER_AI_OBJECT_SPAWN_GHOSTING_COUNTDOWN         (MS_BASE|TIMER|100503)
+#define TIMER_AI_OBJECT_ACTIVATE_COUNTDOWN               (MS_BASE|TIMER|100504)
+#define TIMER_AI_WAIT_FOR_VEHICLE_CONSTRUCT              (MS_BASE|TIMER|100505)
+#define TIMER_AI_GO_TO_VEHICLE_TIMEOUT                   (MS_BASE|TIMER|100506)
+#define TIMER_AI_UNDER_ATTACK                            (MS_BASE|TIMER|100507)
+#define TIMER_AI_REQUEST_DEPLOY                          (MS_BASE|TIMER|100508)
+#define TIMER_AI_POST_CREATED                            (MS_BASE|TIMER|100509)
+#define TIMER_AI_SEARCH_FOR_VEHICLE                      (MS_BASE|TIMER|100510)
+#define TIMER_AI_REFILL_COOLDOWN                         (MS_BASE|TIMER|100511)
+#define TIMER_AI_DEFEND                                  (MS_BASE|TIMER|100512)
+
+#define TIMER_AI_CHECK_FOR_BLOCK                         (MS_BASE|TIMER|100551)
+#define TIMER_AI_CHECK_GET_AROUND_TIMEOUT                (MS_BASE|TIMER|100552)
+#define TIMER_AI_CHECK_UNSTUCK_TIMEOUT                   (MS_BASE|TIMER|100553)
+#define TIMER_AI_CHECK_DISTANCE                          (MS_BASE|TIMER|100554)
+#define TIMER_AI_CHECK_RADAR                             (MS_BASE|TIMER|100555)
+#define TIMER_AI_CHECK_ALLIES                            (MS_BASE|TIMER|100556)
+
+#define TIMER_AI_COOP_RETRY_REQUEST                      (MS_BASE|TIMER|100601)
+#define TIMER_AI_COOP_GROUP_WAIT_TEAM_0                  (MS_BASE|TIMER|100602)
+#define TIMER_AI_COOP_GROUP_WAIT_TEAM_1                  (MS_BASE|TIMER|100603)
+#define TIMER_AI_COOP_PAUSE_INITIATION                   (MS_BASE|TIMER|100604)
+
+#define ACTION_AI_GO_TO_VEHICLE                          (MS_BASE|ACTION|100001)
+#define ACTION_AI_GET_AROUND_REVERSE                     (MS_BASE|ACTION|100002)
+#define ACTION_AI_GET_AROUND_FORWARD                     (MS_BASE|ACTION|100003)
+#define ACTION_AI_RANDOM_MOVING                          (MS_BASE|ACTION|100004)
+
+#define DEFAULT_BOT_NAME                                 "Bot"
+
+#define MS_RGB_JOINLEFT_MSG                              178,178,178     // grey
+#define MS_RGB_DEBUG                                     255,255,255
+
+class Radio_Message_Type
+{
+public:
+	static int BUILDING_NEEDS_REPAIRS;
+	static int GET_IN_THE_VEHICLE;
+	static int GET_OUT_OF_THE_VEHICLE;
+	static int DESTROY_THAT_VEHICLE;
+	static int DONT_GET_IN_MY_WAY;
+	static int AFFIRMATIVE;
+	static int NEGATIVE;
+
+	static int TAKE_THE_POINT;
+	static int MOVE_OUT;
+	static int FOLLOW_ME;
+	static int COVER_ME;
+	static int DESTROY_IT_NOW;
+
+	static int ATTACK_THE_HARVESTER;
+	static int ATTACK_THAT_STRUCTURE;
+	static int DEFEND_THE_BASE;
+	static int DEFEND_THE_HARVESTER;
+	static int DEFEND_THAT_STRUCTURE;
+};
+
+
+class MS_AccessHelper
+{
+public:
+	static void Init_AI_Global_Controller();
+	static int Get_AI_Player_Controllers_Count(int team);
+	static void Give_Bot_Credits(int team, float amount);
+	static float Steal_Bot_Credits(int team, float percentage);
+	static void Receive_Radio_Command(GameObject *sender, int AnnouncementID, int orderType = 0, int orderObjID = 0);
+	static void Send_Radio_Order_To_Bot(GameObject *sender, GameObject *receiver, int radioIndex, int orderType = 0, int orderObjID = 0);
+	static float Get_Money(GameObject *object);
+	static void Give_Money(GameObject *object, float money);
+	static void Activate_Defense_Protocol(int team);
+};
+
+
+class MS_AI_Rally_Point : public ScriptImpClass
+{
+	void Created(GameObject *obj) override;
+	void Destroyed(GameObject *obj) override;
+public:
+	int Get_Team();
+	int Get_NodeGroup();
+	int Get_NodeNum();
+	bool Get_IsInfantryOnly();
+	GameObject *Get_Object();
+};
+
+class MS_AI_Patrol_Point : public MS_AI_Rally_Point
+{
+	void Created(GameObject *obj) override;
+	void Destroyed(GameObject *obj) override;
+};
diff -urN sourceold/scripts/scripts.h source/scripts/scripts.h
--- sourceold/scripts/scripts.h	2019-08-20 10:11:06.818000100 +1000
+++ source/scripts/scripts.h	2020-03-28 21:10:59.047767800 +1000
@@ -318,18 +318,6 @@
 class ActionParamsStruct {
 public:
 	ActionParamsStruct( void );
-	void Set_Basic_Old(ScriptClass *s,unsigned long priority,unsigned long ID,long state);
-	void Set_Attack_Hold(GameObject *Target,float range,float deviation,bool primary,bool Hold);
-	void Set_Attack_Position(const Vector3 & position,float Range,float Deviation,bool Primary);
-	void Set_Goto_Location(const Vector3 & position,float speed,float arrivedistance,bool crouch);
-	void Set_Goto_Following(GameObject *Target,float speed,float arrivedistance,bool following);
-	void Set_Goto_Crouch(GameObject *Target,float speed,float arrivedistance,bool crouch);
-	void Set_Goto_Crouch_Following(GameObject *Target,float speed,float arrivedistance,bool crouch,bool following);
-	void Set_Goto(GameObject *Target,float speed,float arrivedistance);
-	void Set_Goto_Waypath_Start(unsigned long waypathID,unsigned long waypathstartID,unsigned long waypathendID,bool splined);
-	void Set_Goto_Waypath(unsigned long waypathID,bool splined,bool v57,bool Hold);
-	void Set_Goto_Waypath_ID(unsigned long waypathID);
-	void Set_Move_Arrive_Distance(float distance);
 	void Set_Basic( GameObjObserverClass * script, float priority, int action_id, SoldierAIState ai_state = NO_AI_STATE_CHANGE ) { ObserverID = script->Get_ID(); Priority = (int)priority; ActionID = action_id; AIState = ai_state; }
 	void Set_Basic( long observer_id, float priority, int action_id, SoldierAIState ai_state = NO_AI_STATE_CHANGE ) { ObserverID = observer_id; Priority = (int)priority; ActionID = action_id; AIState = ai_state; }
 	void Set_Look( const Vector3 & location, float duration ) { LookLocation = location; LookDuration = duration; }	
@@ -462,89 +450,6 @@
 	LookDuration	= duration;
 	return ;
 }
-void inline ActionParamsStruct::Set_Move_Arrive_Distance(float distance)
-{
-	MoveArrivedDistance = distance;
-}
-void inline ActionParamsStruct::Set_Goto_Location(const Vector3 & position,float speed,float arrivedistance,bool crouch)
-{
-	MoveLocation.X = position.X;
-	MoveLocation.Y = position.Y;
-	MoveLocation.Z = position.Z;
-	MoveSpeed = speed;
-	MoveArrivedDistance = arrivedistance;
-	MoveCrouched = crouch;
-}
-void inline ActionParamsStruct::Set_Goto_Following(GameObject *Target,float speed,float arrivedistance,bool following)
-{
-	MoveObject = Target;
-	MoveSpeed = speed;
-	MoveArrivedDistance = arrivedistance;
-	MoveFollow = following;
-}
-void inline ActionParamsStruct::Set_Goto_Crouch(GameObject *Target,float speed,float arrivedistance,bool crouch)
-{
-	MoveObject = Target;
-	MoveSpeed = speed;
-	MoveArrivedDistance = arrivedistance;
-	MoveCrouched = crouch;
-}
-void inline ActionParamsStruct::Set_Goto_Crouch_Following(GameObject *Target,float speed,float arrivedistance,bool crouch,bool following)
-{
-	MoveObject = Target;
-	MoveSpeed = speed;
-	MoveArrivedDistance = arrivedistance;
-	MoveCrouched = crouch;
-	MoveFollow = following;
-}
-void inline ActionParamsStruct::Set_Goto(GameObject *Target,float speed,float arrivedistance)
-{
-	MoveObject = Target;
-	MoveSpeed = speed;
-	MoveArrivedDistance = arrivedistance;
-}
-void inline ActionParamsStruct::Set_Goto_Waypath_Start(unsigned long waypathID,unsigned long waypathstartID,unsigned long waypathendID,bool splined)
-{
-	WaypathID = waypathID;
-	WaypointStartID = waypathstartID;
-	WaypointEndID = waypathendID;
-	WaypathSplined = splined;
-}
-void inline ActionParamsStruct::Set_Goto_Waypath(unsigned long waypathID,bool splined,bool v57,bool Hold)
-{
-	WaypathID = waypathID;
-	WaypathSplined = splined;
-	AttackActive = v57;
-	AttackCheckBlocked = Hold;
-}
-void inline ActionParamsStruct::Set_Goto_Waypath_ID(unsigned long waypathID)
-{
-	WaypathID = waypathID;
-}
-void inline ActionParamsStruct::Set_Basic_Old(ScriptClass *s,unsigned long priority,unsigned long ID,long state)
-{
-	ID = s->Get_ID();
-	Priority = priority;
-	ActionID = ID;
-	AIState = (SoldierAIState)state;
-}
-void inline ActionParamsStruct::Set_Attack_Hold(GameObject *Target,float Range,float Deviation,bool Primary,bool Hold)
-{
-	AttackObject = Target;
-	AttackRange = Range;
-	AttackError = Deviation;
-	AttackPrimaryFire = Primary;
-	AttackCheckBlocked = Hold;
-}
-void inline ActionParamsStruct::Set_Attack_Position(const Vector3 & position,float Range,float Deviation,bool Primary)
-{
-	AttackRange = Range;
-	AttackLocation.X = position.X;
-	AttackLocation.Y = position.Y;
-	AttackLocation.Z = position.Z;
-	AttackError = Deviation;
-	AttackPrimaryFire = Primary;
-}
 
 enum {
 	CUSTOM_EVENT_SYSTEM_FIRST = 1000000000,
@@ -570,6 +475,7 @@
 	CUSTOM_EVENT_BEACON_DEPLOYED,                                                       //!< Sent when a beacon is deployed
 	CUSTOM_EVENT_REFILL,                                                                //!< Sent on refill at a PT
 	CUSTOM_EVENT_BUILDING_REVIVED,														//!< Sent when building is revived
+	CUSTOM_EVENT_OWNED_VEHICLE,                                                         //!< Special custom sent to the owner of a new vehicle so they can find their vehicle
 };
 
 enum {
diff -urN sourceold/scripts/scripts.vcxproj source/scripts/scripts.vcxproj
--- sourceold/scripts/scripts.vcxproj	2019-06-22 07:31:28.821400000 +1000
+++ source/scripts/scripts.vcxproj	2020-09-26 09:00:03.276360000 +1000
@@ -27,25 +27,25 @@
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
   <ImportGroup Label="ExtensionSettings">
@@ -146,6 +146,7 @@
       <AdditionalLibraryDirectories>..\bin\release</AdditionalLibraryDirectories>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
       <OutputFile>$(OutDir)$(TargetName)$(TargetExt)</OutputFile>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
@@ -225,6 +226,7 @@
       <TargetMachine>MachineX86</TargetMachine>
       <AdditionalLibraryDirectories>..\bin\release</AdditionalLibraryDirectories>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenServerPath (
@@ -293,6 +295,7 @@
       <AdditionalLibraryDirectories>..\bin\debug</AdditionalLibraryDirectories>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
       <OutputFile>$(OutDir)$(TargetName)$(TargetExt)</OutputFile>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
@@ -371,6 +374,7 @@
       <AdditionalLibraryDirectories>..\bin\debug</AdditionalLibraryDirectories>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
       <OutputFile>$(OutDir)$(TargetName)$(TargetExt)</OutputFile>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenServerPath (
@@ -475,9 +479,12 @@
     <ClCompile Include="mdb.cpp" />
     <ClCompile Include="mdbdef.cpp" />
     <ClCompile Include="mdbevf.cpp" />
+    <ClCompile Include="ms.cpp" />
+    <ClCompile Include="ms_ai.cpp" />
     <ClCompile Include="neo.cpp" />
     <ClCompile Include="nh.cpp" />
     <ClCompile Include="nhp.cpp" />
+    <ClCompile Include="ObjectLibraryManager.cpp" />
     <ClCompile Include="PersistFactoryClass.cpp" />
     <ClCompile Include="PointerRemapClass.cpp" />
     <ClCompile Include="Quaternion.cpp" />
@@ -681,6 +688,7 @@
     <ClInclude Include="mdbevf.h" />
     <ClInclude Include="MixFileFactoryClass.h" />
     <ClInclude Include="MoveablePhysDefClass.h" />
+    <ClInclude Include="ms.h" />
     <ClInclude Include="NavalFactoryGameObj.h" />
     <ClInclude Include="NavalFactoryGameObjDef.h" />
     <ClInclude Include="neo.h" />
@@ -688,6 +696,7 @@
     <ClInclude Include="nh.h" />
     <ClInclude Include="nhp.h" />
     <ClInclude Include="obboxclass.h" />
+    <ClInclude Include="ObjectLibraryManager.h" />
     <ClInclude Include="OffenseObjectClass.h" />
     <ClInclude Include="Parameter.h" />
     <ClInclude Include="Persist.h" />
diff -urN sourceold/scripts/scripts.vcxproj.filters source/scripts/scripts.vcxproj.filters
--- sourceold/scripts/scripts.vcxproj.filters	2019-06-22 07:31:28.822400000 +1000
+++ source/scripts/scripts.vcxproj.filters	2020-03-28 21:10:59.049791100 +1000
@@ -380,6 +380,15 @@
     <ClCompile Include="MasterCan_Scripts.cpp">
       <Filter>01. Sources</Filter>
     </ClCompile>
+    <ClCompile Include="ObjectLibraryManager.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+	<ClCompile Include="ms_ai.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="ms.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
   </ItemGroup>
   <ItemGroup>
     <ClInclude Include="ArmedGameObj.h">
@@ -1282,6 +1291,12 @@
     <ClInclude Include="DB_Innate.h">
       <Filter>01. Sources</Filter>
     </ClInclude>
+    <ClInclude Include="ObjectLibraryManager.h">
+      <Filter>01. Sources</Filter>
+    </ClInclude>
+    <ClInclude Include="ms.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
   </ItemGroup>
   <ItemGroup>
     <None Include="documentation\cinematics.dox">
diff -urN sourceold/shared/shared.vcxproj source/shared/shared.vcxproj
--- sourceold/shared/shared.vcxproj	2018-11-17 10:23:57.278600000 +1000
+++ source/shared/shared.vcxproj	2020-09-26 09:00:03.276360000 +1000
@@ -19,14 +19,14 @@
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
     <WholeProgramOptimization>false</WholeProgramOptimization>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
   <ImportGroup Label="ExtensionSettings">
@@ -98,6 +98,7 @@
       <BaseAddress>0x12800000</BaseAddress>
       <TargetMachine>MachineX86</TargetMachine>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
@@ -164,6 +165,7 @@
       <TargetMachine>MachineX86</TargetMachine>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
       <OutputFile>$(OutDir)$(TargetName)$(TargetExt)</OutputFile>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
diff -urN sourceold/swap/Swap.vcxproj source/swap/Swap.vcxproj
--- sourceold/swap/Swap.vcxproj	2018-10-27 22:04:56.583400000 +1000
+++ source/swap/Swap.vcxproj	2020-09-26 09:00:03.277358200 +1000
@@ -20,13 +20,13 @@
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
   <ImportGroup Label="ExtensionSettings">
@@ -108,6 +108,7 @@
       <TargetMachine>MachineX86</TargetMachine>
       <AdditionalLibraryDirectories>..\bin\release SSGM;..\bin\release</AdditionalLibraryDirectories>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
@@ -185,6 +186,7 @@
       <TargetMachine>MachineX86</TargetMachine>
       <AdditionalLibraryDirectories>..\bin\debug SSGM;..\bin\debug</AdditionalLibraryDirectories>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
diff -urN sourceold/tdbedit/tdbedit.vcxproj source/tdbedit/tdbedit.vcxproj
--- sourceold/tdbedit/tdbedit.vcxproj	2018-11-17 10:23:57.287600000 +1000
+++ source/tdbedit/tdbedit.vcxproj	2020-09-26 09:00:03.277358200 +1000
@@ -20,13 +20,13 @@
     <ConfigurationType>Application</ConfigurationType>
     <CharacterSet>Unicode</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'" Label="Configuration">
     <ConfigurationType>Application</ConfigurationType>
     <CharacterSet>Unicode</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
   <ImportGroup Label="ExtensionSettings">
@@ -92,6 +92,7 @@
       <SetChecksum>true</SetChecksum>
       <TargetMachine>MachineX86</TargetMachine>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
@@ -154,6 +155,7 @@
       </LinkTimeCodeGeneration>
       <TargetMachine>MachineX86</TargetMachine>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
diff -urN sourceold/teamspeak/teamspeak.vcxproj source/teamspeak/teamspeak.vcxproj
--- sourceold/teamspeak/teamspeak.vcxproj	2018-10-27 22:04:56.595400000 +1000
+++ source/teamspeak/teamspeak.vcxproj	2020-09-26 09:00:03.278355500 +1000
@@ -20,13 +20,13 @@
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>false</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release SSGM|Win32'" Label="Configuration">
     <ConfigurationType>DynamicLibrary</ConfigurationType>
     <CharacterSet>MultiByte</CharacterSet>
     <WholeProgramOptimization>true</WholeProgramOptimization>
-    <PlatformToolset>v110_xp</PlatformToolset>
+    <PlatformToolset>v110</PlatformToolset>
   </PropertyGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
   <ImportGroup Label="ExtensionSettings">
@@ -108,6 +108,7 @@
       <TargetMachine>MachineX86</TargetMachine>
       <AdditionalLibraryDirectories>..\bin\release SSGM;..\bin\release</AdditionalLibraryDirectories>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
@@ -185,6 +186,7 @@
       <TargetMachine>MachineX86</TargetMachine>
       <AdditionalLibraryDirectories>..\bin\debug SSGM;..\bin\debug</AdditionalLibraryDirectories>
       <ImageHasSafeExceptionHandlers>false</ImageHasSafeExceptionHandlers>
+      <MinimumRequiredVersion>6.01</MinimumRequiredVersion>
     </Link>
     <PostBuildEvent>
       <Command>if defined RenPath (
